/*-
 * Copyright (C)1999..2011 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#ifndef lint
static const char copyright[] = "\
@(#)Copyright (C)1999..2011 @BABOLO http://www.babolo.ru/\n\
@(#)All rights reserved.\n";
static const char rcsid[] = "$Id: mims.c,v 1.14 2014/10/17 08:36:21 babolo Exp $";
#endif /* not lint */

#include "messarge.h"
#include "tables.h"
#include "mescommon.h"

regmatch_t pmatch[8];
regex_t deln_ex, cty_ex, cte_ex, ctf_ex, ctn_ex;
regex_t codk_ex, coda_ex, codw_ex, codi_ex, ctyh_ex, cod_ex;
regex_t cte0_ex, cte1_ex, cte2_ex, cte3_ex, cte4_ex, cte5_ex, cte6_ex, uu_ex;
int v_flag;
FILE *DB_F, *MAIL_F, *NEW_F;
unsigned char mail_f_name[WORK_SIZE];
unsigned ListN, bemail, maxmail;
MASK_T ListM;
struct db *db;
struct db_entry *entries;
int filebdes, filemail, newbdes, blocksize;
unsigned messarge_version;
off_t arcsize;

const char months[][4] =
{ "Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"
, "","","","","","","","","","","",""
};

const char weekdays[][4] = {"Sun","Mon","Tue","Wen","Thu","Fri","Sat"};
const char weekrs[][3] = {"","","","","","",""};

enum quost quost[q_xxx][256] =
{{ q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 00 q_start */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 01 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 02 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 03 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 04 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 05 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 06 */
 , q_start,q_start,q_start,q_start,q_start,q_eq   ,q_start,q_start /* 07 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 10 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 11 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 12 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 13 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 14 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 15 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 16 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 17 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 20 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 21 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 22 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 23 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 24 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 25 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 26 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 27 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 30 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 31 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 32 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 33 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 34 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 35 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 36 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 37 */
 }
,{ q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq    /* 00 q_eq */
 , q_eq   ,q_eq   ,q_start,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq    /* 01 */
 , q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq    /* 02 */
 , q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq   ,q_eq    /* 03 */
 , q_eq   ,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 04 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 05 */
 , q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1     /* 06 */
 , q_1    ,q_1    ,q_start,q_start,q_start,q_start,q_start,q_start /* 07 */
 , q_start,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_start /* 10 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 11 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 12 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 13 */
 , q_start,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_start /* 14 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 15 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 16 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 17 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 20 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 21 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 22 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 23 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 24 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 25 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 26 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 27 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 30 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 31 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 32 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 33 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 34 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 35 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 36 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 37 */
 }
,{ q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1     /* 00 q_1 */
 , q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1     /* 01 */
 , q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1     /* 02 */
 , q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1    ,q_1     /* 03 */
 , q_1    ,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 04 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 05 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 06 */
 , q_start,q_start,q_start,q_start,q_start,q_eq   ,q_start,q_start /* 07 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 10 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 11 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 12 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 13 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 14 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 15 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 16 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 17 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 20 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 21 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 22 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 23 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 24 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 25 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 26 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 27 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 30 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 31 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 32 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 33 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 34 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 35 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 36 */
 , q_start,q_start,q_start,q_start,q_start,q_start,q_start,q_start /* 37 */
}};
enum qpro qpro[q_xxx][256] =
{{ qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 00 q_start */
 , qp_err ,qp_err ,qp_thru,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 01 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 02 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 03 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 04 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 05 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 06 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_skip,qp_thru,qp_thru /* 07 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 10 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 11 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 12 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 13 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 14 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 15 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 16 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 17 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 20 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 21 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 22 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 23 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 24 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 25 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 26 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 27 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 30 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 31 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 32 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 33 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 34 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 35 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 36 */
 , qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru,qp_thru /* 37 */
 }
,{ qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 00 q_eq */
 , qp_err ,qp_err ,qp_skip,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 01 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 02 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 03 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 04 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 05 */
 , qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor /* 06 */
 , qp_stor,qp_stor,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 07 */
 , qp_err ,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_err  /* 10 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 11 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 12 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_sp   /* 13 */
 , qp_err ,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_stor,qp_err  /* 14 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 15 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 16 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 17 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 20 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 21 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 22 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 23 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 24 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 25 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 26 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 27 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 30 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 31 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 32 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 33 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 34 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 35 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 36 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 37 */
 }
,{ qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers  /* 00 q_1 */
 , qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers  /* 01 */
 , qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers  /* 02 */
 , qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers ,qp_ers  /* 03 */
 , qp_ers ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 04 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 05 */
 , qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex  /* 06 */
 , qp_hex ,qp_hex ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 07 */
 , qp_err ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_err  /* 10 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 11 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 12 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 13 */
 , qp_err ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_hex ,qp_err  /* 14 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 15 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 16 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 17 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 20 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 21 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 22 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 23 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 24 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 25 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 26 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 27 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 20 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 21 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 22 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 23 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 24 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 25 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 26 */
 , qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err ,qp_err  /* 27 */
}};

char to_delete[][32] =
{ "From "        ,"From:"        ,"Received:"    ,"X-"
, "To:"          ,"Cc:"          ,"Bcc:"         ,"Reply-To:"
, "In-Reply-To:" ,"Message-Id:"  ,"References:"  ,"Organization:"
, "Subject:"     ,"Sender:"      ,"Precedence:"  ,"MIME-Version:"
, ""
};

const unsigned char tr[4][128] =
{{ 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
 , 144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159
 , 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
 , 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
 , 192,193,194,195,196,197,198,199,200,201,202,203,204,205,206,207
 , 208,209,210,211,212,213,214,215,216,217,218,219,220,221,222,223
 , 224,225,226,227,228,229,230,231,232,233,234,235,236,237,238,239
 , 240,241,242,243,244,245,246,247,248,249,250,251,252,253,254,255
 }                                                     /* code_k */
,{ 225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240
 , 242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241
 , 193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208
 , 136,137,138,139,140,141,142,143,144,145,146,147,148,149,150,151
 , 152,153,154,129,156,157,158,159,160,161,162,163,164,165,166,167
 , 168,169,170,171,172,173,174,175,176,177,178,179,180,181,182,183
 , 210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209
 , 130,132,135,134,128,133,131,155,184,185,186,187,188,189,190,191
 }                                                     /* code_a */
,{ 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
 , 144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159
 , 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
 , 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
 , 225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240
 , 242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241
 , 193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208
 , 210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209
 }                                                     /* code_w */
,{ 128,129,130,131,132,133,134,135,136,137,138,139,140,141,142,143
 , 144,145,146,147,148,149,150,151,152,153,154,155,156,157,158,159
 , 160,161,162,163,164,165,166,167,168,169,170,171,172,173,174,175
 , 225,226,247,231,228,229,246,250,233,234,235,236,237,238,239,240
 , 242,243,244,245,230,232,227,254,251,253,255,249,248,252,224,241
 , 193,194,215,199,196,197,214,218,201,202,203,204,205,206,207,208
 , 210,211,212,213,198,200,195,222,219,221,223,217,216,220,192,209
 , 176,177,178,179,180,181,182,183,184,185,186,187,188,189,190,191
 }                                                     /* code_i */
};

const char b64[] =
{ -3,-2,-2,-2,-2,-2,-2,-2,-2,-1,-1,-2,-2,-1,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -1,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,62,-2,-2,-2,63
, 52,53,54,55,56,57,58,59,60,61,-2,-2,-2,64,-2,-2
, -2, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14
, 15,16,17,18,19,20,21,22,23,24,25,-2,-2,-2,-2,-2
, -2,26,27,28,29,30,31,32,33,34,35,36,37,38,39,40
, 41,42,43,44,45,46,47,48,49,50,51,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
, -2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2,-2
};

char *code_names[] =
{ "none"        ,"koi8-r"      ,"x-cp866"     ,"windows-1251","iso-8859-5"  ,"unknown"     ,"unknown"     ,"unknown" /* 00 */
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown" /* 04 */
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown" /* 10 */
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown" /* 14 */
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
, "unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"     ,"unknown"
};

char *th_names[] = {"root", "cousen", "brother", "child", "hidden", "purge"};
char *encapsulation_names[] = {"none", "7bit", "8bit", "binary", "quoted-printable", "base64", "x-uuencode"};

void
perr(int eval, const char *fmt) {
    fprintf(stderr, "%s: ", getprogname());
    perror(fmt);
    exit(eval);
}

MASK_T
tomask(unsigned char *p) {
    MASK_T u = 0;
    int i;

    for (i = 0; i < db->header.LList; i++) u |= p[i] << (8 * i);
    return(u);
}

off_t
open_db(char *name, enum open_m upd) {
    int errrr = 0, i, j = 5;
    struct stat sb, sb1;

begin:
    if  (stat(name, &sb))                                                        perr(EX_NOINPUT, name);
    errrr = 1;
    if  (upd == update_m) {
         if  ((filebdes = open(name, O_RDWR)) < 0)                               perr(EX_CANTCREAT, name);
         if  (flock(filebdes, LOCK_EX))                                          perr(EX_IOERR, name);
         if  ((DB_F = fdopen(filebdes, "a+")) == NULL)                           perr(EX_IOERR, name);
    } else {
        if  ((filebdes = open(name, O_RDONLY)) < 0)                              perr(EX_NOINPUT, name);
        if  (flock(filebdes, LOCK_SH))                                           perr(EX_IOERR, name);
        if  ((DB_F = fdopen(filebdes, "r")) == NULL)                             perr(EX_IOERR, name);
    }
    errrr = 10;
    if  (fseek(DB_F, 0, SEEK_SET))                                               perr(EX_IOERR, name);
    bzero(&db->header, sizeof(struct db_header));
    (void)fread(&db->header, sizeof(struct db_header), 1, DB_F);
    errrr = 11;
    if  (ferror(DB_F))                                                           perr(EX_IOERR, name);
    errrr = 12;
    if  (ftell(DB_F) < (long)sizeof(unsigned) * 4)                               goto db_err;
    messarge_version = db->header.magic;
    errrr = 13;
    if  (db->header.len < 1)                                                     goto db_err;
    switch (messarge_version) {
    /* this is place for version converting code */
    case MAGIK_00:
        errrr = 14;
        if  (upd != old_m)                                                       goto db_err;
        blocksize =   (void*)((struct db_entry_00 *)(&db->entry))->var
                    - (void*)((struct db_entry_00 *)(&db->entry))
                    + db->header.var_size;
        errrr = 15;
        if  (ftell(DB_F) < (void*)&db->header - (void*)&db->header.path[2])      goto db_err;
        db->header.magic = MAGIK_VV;
        break;
    case MAGIK_VV:
        blocksize = (void*)db->entry.var - (void*)&db->entry + db->header.var_size;
        errrr = 16;
        if  (ftell(DB_F) < (void*)&db->header - (void*)&db->header.path[2])      goto db_err;
        break;
    default: errrr = 17;                                                         goto db_err;
    }
    if  ((unsigned)(ftell(DB_F) / blocksize) < db->header.len)                   goto db_err;
    errrr = 21;
    if  (sb.st_size % blocksize)                                                 goto db_err;
    errrr = 22;
    if  (db->header.var_size < 4)                                                goto db_err;
    errrr = 23;
    if  (upd == readup_m && j-- && db->header.flags & MAKE_ON_WAKEUP) {
        if  (stat(db->header.path, &sb1))                                        perr(EX_NOINPUT, db->header.path);
        errrr = 30;
        if  (sb.st_mtime < sb1.st_mtime) {
            if  (fclose(DB_F))                                                   goto db_err;
            errrr = 31;
            i = fork();
            if  (i < 0)                                                          perr(EX_CONFIG, NULL);
            errrr = 32;
            if  (i == 0) {
                char *p, *dbc_name;

                dbc_name = malloc(strlen(getprogname()) + strlen(MESRDBC));
                errrr = 50;
                if  (!dbc_name) goto db_err;
                strcpy(dbc_name, getprogname());
                p = rindex(getprogname(), '/');
                if  (p) *(p + 1) = '\0'; else dbc_name[0] = '\0';
                strcat(dbc_name, MESRDBC);
                execlp(dbc_name, dbc_name, "-u", name, NULL);                    perr(EX_CONFIG, NULL);
            }
            (void)wait(&i);
            errrr = 33;
            if  (!(WIFEXITED(i)))                                                goto db_err;
            errrr = 34;
            if  (WEXITSTATUS(i))                                                 goto db_err;
            goto begin;
    }   }
    if  (fseek(DB_F, (long)DB_BLOCK_SIZE * db->header.len, SEEK_SET))            perr(EX_IOERR, name);
    return(sb.st_size);
db_err:
    fprintf(stderr, "Illegal DB %s, code = %d\n", name, errrr);                  exit(EX_DATAERR);
}

void
exr(regex_t *preg, const char *pattern, int cflags) {
    int err;
    char buffer[132];

    if  (!(err = regcomp(preg, pattern, cflags))) return;
    (void)regerror(err, preg, buffer, 132);
    fprintf(stderr, "%s: %s:%s\n", getprogname(), pattern, buffer);
    exit(EX_SOFTWARE);
}

#ifdef WEAK_REG_EX
#   undef REG_STARTEND
#   define REG_STARTEND end
int
REGEXEC( const regex_t *preg
       , char *string
       , size_t nmatch
       , regmatch_t pmatch[]
       , char *end
       ) {
/* This is ABSOLUTLY invalid in common case! Be careful ! */
    int i, j;
    size_t mlen = nmatch;
    off_t eoffset = pmatch[0].rm_eo, soffset = pmatch[0].rm_so;
    char save;

    if  (&string[eoffset] > end)  eoffset--;
/* it is possible because we have at least /n/n at end, if not a body */
    save = string[eoffset];
    string[eoffset] = '\0';
    i = regexec(preg, &string[pmatch[0].rm_so], nmatch, pmatch, 0);
    for (j = 0; j < mlen; j++) {
        if  (pmatch[j].rm_so != -1) pmatch[j].rm_so += soffset;
        if  (pmatch[j].rm_eo != -1) pmatch[j].rm_eo += soffset;
    }
    string[eoffset] = save;
    return(i);
}
#else
#   define REGEXEC(a,b,c,d,e) regexec(a,b,c,d,e)
#endif

void
miminit() {
    exr(&deln_ex, "\n[ \t]+", REG_EXTENDED);
    exr(&cty_ex, "(^|\n)Content-Type:[ \t]*([^\n]+)\n", REG_EXTENDED | REG_ICASE);
    exr( &ctf_ex
       , "(^|\n)Content-Disposition:.*[ \t;]filename=\"?([^ \t\n\";]+)([ \t\";][^\n]*)?\n"
       , REG_EXTENDED | REG_ICASE);
    exr( &ctn_ex
       , "(^|\n)Content-Type:.*[ \t;]name=\"?([^ \t\n\";])([ \t\";][^\n]*)?\n"
       , REG_EXTENDED | REG_ICASE);
    exr(&cte_ex, "(^|\n)Content-Transfer-Encoding:[ \t]*([^ \t\n]+)[ \t]*\n", REG_EXTENDED | REG_ICASE);
    exr(&cte0_ex, "^7BIT$"            , REG_EXTENDED | REG_ICASE);
    exr(&cte1_ex, "^8BIT$"            , REG_EXTENDED | REG_ICASE);
    exr(&cte2_ex, "^binary$"          , REG_EXTENDED | REG_ICASE);
    exr(&cte3_ex, "^quoted-printable$", REG_EXTENDED | REG_ICASE);
    exr(&cte4_ex, "^base64$"          , REG_EXTENDED | REG_ICASE);
    exr(&cte5_ex, "^x-uuencode$"      , REG_EXTENDED | REG_ICASE);
    exr(&cte6_ex, "^uuencode$"        , REG_EXTENDED | REG_ICASE);
    exr(&uu_ex, "(^|\n)begin "        , REG_EXTENDED);
    exr( &codk_ex
       , "^text/[-.a-z0-9]+[ \t]*;.*charset[ \t]*=[ \t]*\"?KOI8-R"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &coda_ex
       , "^text/[-.a-z0-9]+[ \t]*;.*charset[ \t]*=[ \t]*\"?X-CP866"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &codw_ex
       , "^text/[-.a-z0-9]+[ \t]*;.*charset[ \t]*=[ \t]*\"?WINDOWS-1251"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &codi_ex
       , "^text/[-.a-z0-9]+[ \t]*;.*charset[ \t]*=[ \t]*\"?ISO-8859-5"
       , REG_EXTENDED | REG_ICASE
       );
    exr(&cod_ex, "^text/[-.a-z0-9]+[ \t]*", REG_EXTENDED | REG_ICASE);
    exr(&ctyh_ex, "^text/html", REG_EXTENDED | REG_ICASE);
/*  exr( &cty1_ex
 *     , "^MULTIPART/[-A-Z0-9]+[ \t]*;.*BOUNDARY=([-!#$%&'*+.^_`\\{\\}\\|~--A-Z0-9])"
 *     , REG_EXTENDED | REG_ICASE
 *     );
 */
}

int
print_escaped(char c) {
    switch (c) {
    case '\0': putchar('\\'); return(-1);
    case 'n' : putchar('\n');           break;
    case 't' : putchar('\t');           break;
    case 'v' : putchar('\v');           break;
    case 'b' : putchar('\b');           break;
    case 'r' : putchar('\r');           break;
    case 'f' : putchar('\f');           break;
    case '\\': putchar('\\');           break;
    case '\'': putchar('\'');           break;
    case '\"': putchar('\"');           break;
    case '0' : putchar('\0');           break;
    default  : putchar('\\'); putchar(c);
    }
    return(0);
}

void
print_s_escaped(unsigned char p[]) {
    int i, j;

    j = 0;
    if  (p) {
        for (i = 0; !j && p[i]; i++) {
            if  (p[i] == '\\') j += print_escaped(p[++i]); else putchar(p[i]);
}   }   }

#if 0
char *
strnstr(char *bs, char *s, off_t bl) {
    char *p = bs;

    while ((p = memchr(p, s[0], bs + bl - p))) {
        if  (strlen(s) > (bs + bl - p) || strncmp(p, s, strlen(s))) p++; else break;
    }
    return(p);
}
#endif

char *
s_find(char *bs, off_t bl, char *ss, off_t sl) {
    char *p;
    off_t l;

    p = bs;
    while ((p = strnstr(p, "\n--", bl))) {
        p += 3;
        l = bs + bl - p;
        if  (!strncmp(p, ss, (l > sl) ? sl : l)) return(p - 2);
    }
    return(NULL);
}

int
nibble(unsigned char c) {
    const unsigned char code[] = "0123456789ABCDEF0123456789abcdef";
    int p;

    p = 0;
    while (code[p]) if (c == code[p]) return(p & 017); else p++;
    return(-1);
}

void
print_www_escaped(char *s) {
    while (*s) {
        if  (*s == '#') printf("%%%02X", *s++); else putchar(*s++);
}   }

void
nw_transfer(unsigned char cc, unsigned charset, int flags) {
    int e = charset & 0377 & ~CODEMASK;
    int c = cc & 0377;

    if  (flags & WWW_FLAG && !(charset & CODEMASK)) {
        switch (c) {
        case '&': printf("&amp;");   break;
        case '<': printf("&lt;");    break;
        case '>': printf("&gt;");    break;
        case '\"': printf("&quot;"); break;
        default : putchar(   (c < 128 || !e)
                           ? c
                           : (e < (int)(sizeof(tr) / sizeof(tr[0]))) ? tr[e - 1][c - 128] : 0
                         );
        }
    } else if (!(flags & BIN_FLAG)) {
        putchar( (c < 128 || !e)
               ? c : (e < (int)(sizeof(tr) / sizeof(tr[0]))) ? tr[e - 1][c - 128]
               : 0
               );
    } else {
        putchar(c & 0377);
}   }

unsigned
uud(unsigned char c) {
    if  (c > 0140) exit(1);
    if  (c == 0140) return(0);
    if  (c >= 0040) return(c - 0040);
    exit(2);
}

size_t
rm_reg(unsigned char *arr, size_t len, size_t gap_beg, size_t gap_end) {
    bcopy(&arr[gap_end], &arr[gap_beg], (size_t)(len - gap_end));
    bzero(&arr[len - (gap_end - gap_beg)], gap_end - gap_beg);
    return(len - (gap_end - gap_beg));
}

void
mime_transfer( char *begin
             , unsigned len
             , struct shformat shformat
             , int flags
             , unsigned *chnum
             ) {
    unsigned char *p, *headers = (unsigned char *)begin, *end = (unsigned char *)begin + len;
    unsigned i, stor = 0;
    int j, k;
    size_t headlen;
    unsigned charset, encapsulation;
    enum quost q_st;
    char *Fnam = NULL;

    begin = strnstr(begin, "\n\n", len);
    if  (begin) {
        begin += 2;
        headlen = (size_t)begin - (size_t)headers;
        pmatch[0].rm_so = 0;
        pmatch[0].rm_eo = headlen;
        while (!REGEXEC(&deln_ex, (char*)headers, 8, pmatch, REG_STARTEND)) {
            headlen = rm_reg(headers, headlen, pmatch[0].rm_so, pmatch[0].rm_eo);
            pmatch[0].rm_so = 0;
            pmatch[0].rm_eo = headlen;
        }
        for (k = 1; k;) {
            k = 0;
            for (j = 0; to_delete[j][0]; j++) {
                if  (  strlen(to_delete[j]) < headlen
                    && !strncasecmp((char*)headers, to_delete[j], strlen(to_delete[j]))
                    ) {
                    unsigned char *t = memchr(headers, '\n', headlen);

                    if  (t++) {
                        headlen -= t - headers;
                        headers = t;
                        k++;
        }   }   }   }
        for (i = 0, k = 1; k;) {
            k = 0;
            for (j = 0; to_delete[j][0]; j++) {
                if  (  strlen(to_delete[j]) < headlen
                    && !strncasecmp((char*)&headers[i], to_delete[j], strlen(to_delete[j]))
                    ) {
                    unsigned char *t = memchr(&headers[i], '\n', headlen - i);
                    if  (t++) {
                        headlen = rm_reg(headers, headlen, i, t - headers);
                        k++;
            }   }   }
            if  (!k) {
                unsigned char *t = memchr(&headers[i], '\n', headlen - i);

                if  (t++) {
                    i = t - headers;
                    k++;
        }   }   }
        if  (!REGEXEC(&ctf_ex, (char*)headers, 8, pmatch, REG_STARTEND)) {
            Fnam = malloc(pmatch[2].rm_eo - pmatch[2].rm_so);
            for (i = 0; i < pmatch[2].rm_eo; i++) Fnam[i] = headers[i + pmatch[2].rm_so];
            Fnam[pmatch[2].rm_eo - pmatch[2].rm_so] = '\0';
            headlen = rm_reg(headers, headlen, pmatch[1].rm_eo, pmatch[0].rm_eo);
            pmatch[0].rm_so = 0;
            pmatch[0].rm_eo = headlen;
        } else if (!REGEXEC(&ctn_ex, (char*)headers, 8, pmatch, REG_STARTEND)) {
            Fnam = malloc(pmatch[2].rm_eo - pmatch[2].rm_so);
            for (i = 0; i < pmatch[2].rm_eo; i++) Fnam[i] = headers[i + pmatch[2].rm_so];
            Fnam[pmatch[2].rm_eo - pmatch[2].rm_so] = '\0';
            pmatch[0].rm_so = 0;
            pmatch[0].rm_eo = headlen;
        }
        encapsulation = none_enc;
        if  (!REGEXEC(&cte_ex, (char*)headers, 8, pmatch, REG_STARTEND)) {
            if      (!REGEXEC(&cte0_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = bit7;
            else if (!REGEXEC(&cte1_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = bit8;
            else if (!REGEXEC(&cte2_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = binary;
            else if (!REGEXEC(&cte3_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = quoted;
            else if (!REGEXEC(&cte4_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = base64;
            else if (!REGEXEC(&cte5_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = uu;
            else if (!REGEXEC(&cte6_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) encapsulation = uu;
            if  (encapsulation) headlen = rm_reg(headers, headlen, pmatch[1].rm_eo, pmatch[0].rm_eo);
            pmatch[0].rm_so = 0;
            pmatch[0].rm_eo = headlen;
        }
        charset = no_code;
        if  (!REGEXEC(&cty_ex, (char*)headers, 8, pmatch, REG_STARTEND)) {
            if      (!REGEXEC(&codk_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) charset = code_k;
            else if (!REGEXEC(&coda_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) charset = code_a;
            else if (!REGEXEC(&codw_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) charset = code_w;
            else if (!REGEXEC(&codi_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) charset = code_i;
            else if (REGEXEC(&cod_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) charset = code_unknown;
            if  (!REGEXEC(&ctyh_ex, (char*)headers, 0, &pmatch[2], REG_STARTEND)) charset |= CODEMASK;
            if  (charset && charset != code_unknown) {
                headlen = rm_reg(headers, headlen, pmatch[1].rm_eo, pmatch[0].rm_eo);
        }   }
        if  (v_flag > 2) fprintf( stderr, "code=%u<%s> (%s) encaps=%s\n"
                                , charset & 0377 & ~CODEMASK
                                , code_names[charset & 0377 & ~CODEMASK]
                                ,   (charset & CODEMASK)
                                  ? "text/html"
                                  :   ((charset & 0377 & ~CODEMASK) == code_unknown)
                                    ? "*/*"
                                    : "text/plain"
                                , encapsulation_names[encapsulation & 0377]
                                );
        if  (((charset & ~CODEMASK) != code_unknown) || flags & BIN_FLAG) {
            if  (  (flags & WWW_FLAG)
                && !(flags & BIN_FLAG)
                && !(charset & CODEMASK)
                ) print_s_escaped(shformat.B_str);
        ;   if  (flags & HDR_FLAG) {
                if  (charset & ~CODEMASK && ((charset & ~CODEMASK) != code_unknown))
                    printf( "Content-Type: text/%s;charset=%s\n"
                          , (charset & CODEMASK) ? "html" : "plain"
                          , code_names[charset & ~CODEMASK]
                          );
        ;       if  (Fnam) printf("Content-Disposition: filename=\"%s\"\n", Fnam);
        ;       for (i = 0; i < headlen; i++) putchar(headers[i]);
        ;   }
        ;   switch (encapsulation) {
            case binary:
        ;       if  (!(flags & BIN_FLAG)) break;
        ;   case none_enc:
        ;       /* FALLTHROUGH */
        ;   case bit7:
        ;       /* FALLTHROUGH */
        ;   case bit8:
        ;       for (p = (unsigned char *)begin; p < end; p++) nw_transfer(*p, charset, flags);
        ;       break;
        ;   case quoted:
        ;       for (q_st = q_start, p = (unsigned char *)begin; p < end; p++) {
        ;           switch (qpro[q_st][*p]) {
        ;           case qp_thru:
        ;               nw_transfer(*p, charset, flags);
        ;               break;
        ;           case qp_stor:
        ;               stor = nibble(*p) << 4;
        ;               break;
        ;           case qp_hex:
        ;               nw_transfer(stor | nibble(*p), charset, flags);
        ;               break;
        ;           case qp_sp:
        ;               putchar(' ');
        ;               break;
        ;           case qp_err:
        ;               nw_transfer(*p, charset, flags);
        ;           case qp_ers:
        ;               printf("(!!!)");
        ;           case qp_skip:
        ;           }
        ;           q_st = quost[q_st][*p];
        ;       }
        ;       /* XXXX test q_st */;
        ;       break;
        ;   case base64:
        ;       for (i = 0, p = (unsigned char *)begin; p < end; p++) {
        ;           if  ((j = b64[*p]) >= 0) {
        ;               if  (j & 0300 && !stor) break;
        ;               switch (i++ & 3) {
                        case 0:
        ;                   stor = ((j & 077) << 2) & 0377;
        ;                   break;
        ;               case 1:
        ;                   nw_transfer(stor | (j & 077) >> 4, charset, flags);
        ;                   stor = ((j & 077) << 4) & 0377;
        ;                   break;
        ;               case 2:
        ;                   nw_transfer(stor | (j & 077) >> 2, charset, flags);
        ;                   stor = ((j & 077) << 6) & 0377;
        ;                   break;
        ;               case 3:
        ;                   nw_transfer(stor | (j & 077), charset, flags);
        ;               }
        ;               if  (j & 0300) break;
        ;       }   }
        ;       break;
        ;   case uu:
        ;       pmatch[0].rm_so = 0;
        ;       pmatch[0].rm_eo = (size_t)end - (size_t)begin;
        ;       if  (REGEXEC(&uu_ex, begin, 1, pmatch, REG_STARTEND)) {
        ;           p = (unsigned char *)begin;
        ;       } else {
        ;           p = (unsigned char *)&begin[pmatch[0].rm_eo];
        ;       }
        ;       while (  (p == (unsigned char *)begin)
                      || (p = (unsigned char*)memchr((void*)p, '\n', end - p))
                      ) {
        ;           if  (p != (unsigned char *)begin) p++;
        ;           if  (!(j = uud(*p++))) break;
        ;           for (i = 0; j > 0;) {
                        switch (i++ & 3) {
                        case 0:
        ;                   stor = uud(*p++) << 2;
        ;                   break;
        ;               case 1:
        ;                   nw_transfer(stor | uud(*p) >> 4, charset, flags);
        ;                   j--;
        ;                   stor = (uud(*p++) << 4) & 0377;
        ;                   break;
        ;               case 2:
        ;                   nw_transfer(stor | uud(*p) >> 2, charset, flags);
        ;                   j--;
        ;                   stor = (uud(*p++) << 6) & 0377;
        ;                   break;
        ;               case 3:
        ;                   nw_transfer(stor | uud(*p++), charset, flags);
        ;                   j--;
        ;   }   }   }   }
        ;   if  (  (flags & WWW_FLAG)
                && !(flags & BIN_FLAG)
                && !(charset & CODEMASK)
                ) print_s_escaped(shformat.E_str);
        } else {
            char c, *f = (char*)shformat.A_str;
            int i;

            while ((c = *f++)) {
                if  (c == '\\') {
                    print_escaped(c = *(f++));
                } else if (c == '%') {
                    switch (c = *(f++)) {
                    case '\0':
                        nw_transfer('%', charset, flags);
                        break;
                    case 'P':
                        for (i = 0; chnum[i]; i++) printf("%s%u", i ? "/" : "" , chnum[i]);
                        break;
                    case 'F':
                        printf("%s", Fnam ? Fnam : "(no name)");
                        break;
                    default:
                        printf("%%%c", c);
                    }
                } else {
                    putchar(c);
        }   }   }
        if  (Fnam) free(Fnam);
}   }

void
multi_transfer( char *pos, unsigned len
              , unsigned boundp, unsigned boundl
              , struct shformat shformat
              , char *chain
              , int flags
              , unsigned *chnum
              ) {
    char *begin, *end;
    unsigned j;
    int not_1 = 0;
    int Nchain = 0, chained = 0;
    unsigned *chnump, cp;

    for (cp = 0; chnum[cp]; cp++);
    if  ((chnump = malloc(cp * sizeof(unsigned))) == NULL)                 perr(EX_UNAVAILABLE, NULL);
    for (j = 0; j < cp; j++) chnump[j] = chnum[j];
    chnump[cp + 1] = 0;
    if  (chain && chain[0] == '/') {
        do chain++; while (chain[0] && chain[0] == '/');
        Nchain = strtol(chain, &chain, 0);
        chained = 1;
    }
    begin = NULL;
    end = pos + boundp + boundl;
    for (j = 0; (end = s_find(end, pos + len - end, pos + boundp, boundl)); j++) {
        if  (begin && (!chained || j == Nchain)) {
            if  (not_1) print_s_escaped(shformat.T_str);
            chnump[cp] = j;
            mime_transfer(begin, end - begin, shformat, flags, chnump);
            not_1 = 1;
        }
        begin = memchr(end, '\n', pos + len - end);
        if  (!(begin++)) break;
        end = begin;
    }
    free(chnump);
}
